<template>
  <el-main>
    <el-form ref="form" :model="form" label-width="80px">
      <el-row>
        <el-col :span="12">
          <el-form-item label="文号">
            <el-input v-model="form.name"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="当事人">
            <el-input v-model="form.name"></el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-form-item label="有关事实">
        <el-input v-model="form.name"></el-input>
      </el-form-item>
      <el-form-item>
        <el-checkbox-group v-model="form.checkList">
          <el-checkbox label="A" style="display: block!important;margin-bottom:5px!important">
            请贵单位于
            <el-date-picker
              v-model="form.value1"
              type="date"
              style="display: inline-block!important;width: 140px!important;"
              placeholder="选择日期">
            </el-date-picker>
            前将以下资料寄送到我单位：
          </el-checkbox>
          <el-checkbox label="B" style="display: block!important;">
            我单位将于
            <el-date-picker
              v-model="form.value1"
              type="date"
              style="display: inline-block!important;width: 140px!important;"
              placeholder="选择日期">
            </el-date-picker>
            到贵单位处进行调查：
          </el-checkbox>
        </el-checkbox-group>
      </el-form-item>
      <el-form-item label="提供资料">
        <el-input type="textarea" :row="2" v-model="form.name"></el-input>
      </el-form-item>
      <el-row>
        <el-col :span="12">
          <el-form-item label="联系人">
            <el-input type="text" v-model="form.name" placeholder="联系人"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="联系电话">
            <el-input type="text" v-model="form.name" placeholder="联系电话"></el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-form-item label="单位地址">
        <el-input type="text" v-model="form.name" placeholder="单位地址"></el-input>
      </el-form-item>
      <el-form-item label="扣章日期">
        <el-date-picker
          v-model="form.value1"
          type="date"
          placeholder="扣章日期">
        </el-date-picker>
      </el-form-item>
      <WordView ref="wordInfo" :isShowYulan="showView" @cancel="cancelWord"></WordView>
    </el-form>
    <div style="text-align: center">
      <el-button v-if="form.registerState!='1'" plain @click="dataFormSubmit('0')">保存</el-button>
      <el-button v-if="form.registerState!='1'" type="warning" plain @click="dataFormSubmit('1')">定稿</el-button>
      <el-button type="primary" plain @click="viewVord(form)">预览</el-button>
      <el-button type="success" plain @click="downloadWord(form)">下载</el-button>
    </div>
  </el-main>
</template>

<script>
import WordView from "@/views/News/word-view";
import goodsDisposeList from "@/views/News/word-manage/externalFile/saveproofDisposeInform/goodsDisposeList";
import {getObj, saveObj} from "@/api/News/saveproofDisposeInform";
import {getLaw, lawInfo} from "@/api/lawList/lawList";
import moment from "moment";

export default {
  name: "AssistanceInInvestigations",
  props: ['isShowYulan', 'id', 'isFinish', 'processId', 'title'],
  components: {
    WordView,
  },
  data() {
    return {
      isShow: false,
      showView: false,
      form: {
        unitName: "",
        litigant: "",
        informDate: "",
        agencyName: "",
        noticeUnitName: "",
        exhibitName: "",
        beginTime: "",
        endTime: "",
        legalProvisions: "",
        legalProvisionsTiao: "",
        legalProvisionsKuan: "",
        legalProvisionsXiang: "",
        enforcementPersonOne: "",
        certificateNumberOne: "",
        enforcementPersonTwo: "",
        certificateNumberTwo: "",
        recordDate: "",
        checkList: [],
      },
      lawList: [],
      lawTiaoList: [],
      formLabelWidth: "120px",
    }
  },
  created() {
    this.init()
  },
  methods: {
    init() {
      getObj(this.id).then((res) => {
        // 转换null为""
        let v = res.data.data;
        for (let attr in v) {
          if (v[attr] == null) {
            v[attr] = "";
          }
        }
        let str = JSON.stringify(v);
        let data = JSON.parse(str);
        this.form = data;
      });
    },
    querySearchHandle(queryString, cb) {  //模糊搜素
      getLaw(queryString).then(res => {
        this.lawList = []
        let resultList = res.data.data
        resultList.forEach(item => {
          this.lawList.push({
            value: item.name,
            id: item.id
          })
        })
        cb(this.lawList)
      })
    },
    handleSelect(item) {
      this.form.legalProvisions = item.value
      this.form.lawId = item.id
      lawInfo(item.value).then(res => {
        this.lawTiaoList = res.data.data
      })
    },
    openForm() {
      this.isShow = true;
    },
    cancell(e, d) {
      this.isShow = e;
      if (d != undefined) {
        this.form.goodsDis.push(d)
      }
    },
    dataFormSubmit(type) {
      this.$refs['form'].validate((valid) => {
        if (valid) {
          let obj = this;
          if ("1" == type) {
            this.$confirm('保存为定稿将不能修改，是否继续？', '提示', {
              confirmButtonText: '是',
              cancelButtonText: '否',
              type: 'warning'
            }).then(function () {
              obj.form.registerState = type;
              obj.form.registerId = obj.id;
              obj.form.processId = obj.processId;
              saveObj(obj.form).then((res) => {
                // this.submitLoading = false;
                obj.$message.success('操作成功');
                obj.cancel();
                obj.$emit('getDataList');
              })
            })
          } else {
            obj.form.registerState = type;
            obj.form.registerId = obj.id;
            obj.form.processId = obj.processId;
            saveObj(obj.form).then((res) => {
              // this.submitLoading = false;
              obj.$message.success("操作成功");
              obj.cancel();
              obj.$emit('getDataList');
            })
          }
        }
      })
    },
    cancel() {
      this.$emit('cancel', false);
    },
    cancelWord() {
      this.showView = false;
    },
    viewVord(data) {
      if (data.registerState == null || data.registerState == "") {
        //预览前先进行保存
        data.registerState = '0';
        data.registerId = this.id;
        data.processId = this.processId;
        saveObj(data).then((res) => {
        })
      }
      //↓↓↓↓↓↓以下部分根据具体业务修改↓↓↓↓↓↓
      //格式转换
      let wordData = this.transforData(data);
      //↑↑↑↑↑↑以上部分根据具体业务修改↑↑↑↑↑↑
      this.showView = true;
      this.$nextTick(() => {
        this.$refs.wordInfo.init(wordData, "/wordes/saveproofDisposeInform.docx");
      })
    },
    downloadWord(data) {
      if (data.registerState == null || data.registerState == "") {
        //预览前先进行保存
        data.registerState = '0';
        data.registerId = this.id;
        data.processId = this.processId;
        saveObj(data).then((res) => {
        })
      }
      let wordData = this.transforData(data);
      WordView.methods.exportDoc(wordData, "/wordes/saveproofDisposeInform.docx", this.title + '.docx');
    },
    transforData(obj) {
      let s = JSON.stringify(obj);
      let data = JSON.parse(s);
      if (data.informDate != '' && data.informDate != null) {
        data.informDate = moment(data.informDate).format('YYYY年MM月DD日');
      } else {
        data.informDate = '  年  月  日'
      }
      if (data.beginTime != '' && data.beginTime != null) {
        data.beginTime = moment(data.beginTime).format('YYYY年MM月DD日');
      } else {
        data.beginTime = '  年  月  日'
      }
      if (data.endTime != '' && data.endTime != null) {
        data.endTime = moment(data.endTime).format('YYYY年MM月DD日');
      } else {
        data.endTime = '  年  月  日'
      }
      if (data.recordDate != '' && data.recordDate != null) {
        data.recordDate = moment(data.recordDate).format('YYYY年MM月DD日');
      } else {
        data.recordDate = '  年  月  日'
      }
      let goods = data.goodsDis;
      for (let index in goods) {
        if (goods[index].productionDate == null) {
          goods[index].productionDate = "";
        }
      }
      let arr = this.formatArr(data.goodsDis, 6)
      if (data.goodsDis.length > 5) {
        data.goodsDis = [...arr]
      } else {
        data.goodsDis = [...data.goodsDis, ...arr]
      }
      for (let i = 1; i <= data.goodsDis.length; i++) {
        if (data.goodsDis[i - 1].productionDate == null) {
          data.goodsDis[i - 1].productionDate = '';
        }
        if (data.goodsDis[i - 1].exhibitName != null && data.goodsDis[i - 1].exhibitName != "") {
          data.goodsDis[i - 1].index = i + '';
        } else {
          data.goodsDis[i - 1].index = '';
        }
      }
      return data;
    },
    formatArr(arr, n) {
      let len = arr.length
      if (n < len) {
        return arr.filter((item, num) => num < n)
      } else {
        return new Array(n - len).fill({
          index: '',
          exhibitName: '',
          brand: '',
          origin: '',
          exhibitSize: '',
          productionDate: '',
          exhibitNum: '',
          handlingSituation: ''
        })
      }
    },
    deleteByRow(str) {
      this.form.goodsDis.splice(str, 1)
    },
  }
}
</script>

<style scoped>

</style>
